/* Copyright (c) 2010 ZAO "MCST". All rights reserved.
 *
 * @(#) $Id: dprof_api.h,v 1.5 2013-12-31 14:50:10 breger Exp $
 */

#ifndef DPROF_API_H
#define DPROF_API_H

#ifdef __e2k__
/* illigal instruction to cause SIGILL */
#define DPROF_TOGGLE_MARKER_OLD     0x0dc0c08004000001ull
/* Changed to GDB_BREAKPOINT_STUB to block debug printk's from kernel */
/* Kernel will send SIGTRAP */
#define DPROF_TOGGLE_MARKER     0x0dc0c08104000001ull

/* turn tracing on or off */
/* FIXME: lir doesn't accept .dword */
/* FIXME: -masm-inline doesn't accept .word */
/* GDB_BREAKPOINT_STUB */
#define dprof_toggle_tracing()  asm(".word 0x04000001; .word 0x0dc0c080")


#elif defined( __sparc__)

/* gdb/sparc-tdep.c sparc_breakpoint_from_pc  gdb_byte break_insn
 * 91 d0 20 01
 */
#define DPROF_TOGGLE_MARKER 0x91d02001
#define dprof_toggle_tracing()  asm(".word 0x91d02001")


#elif defined(__x86__) || defined(__x86_64__)
/* Temporary variant; not supported to toggle */
#define dprof_toggle_tracing()  asm(" int3")

#else
/* put new arch code here */

#endif

#endif /* DPROF_API_H */

